//Hunger Mod
//Version v5 Dev
//By Tom the Polymer

//Default Settings
if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
   if(!$RTB::RTBR_ServerControl_Hook)
      exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
      
  // RTB_registerPref("Hunger","Hunger Mod","Hunger::On","bool","Script_Hunger",1,0,0);
   RTB_registerPref("Hunger Tick (seconds)","Hunger Mod","Hunger::TickTime","int 3 480","Script_Hunger",60,0,0);
   RTB_registerPref("Cannibalism","Hunger Mod","Hunger::EatPeeps","bool","Script_Hunger",0,0,0);
   RTB_registerPref("Food Cost","Hunger Mod","Hunger::FoodCost","int 0 100","Script_Hunger",10,0,0);
   RTB_registerPref("Events","Hunger Mod","Hunger::Event","bool","Script_Hunger",1,0,0);
   RTB_registerPref("Food in Horses","Hunger Mod","hunger::FoodHorse","int 0 100","Script_Hunger",5,0,0);
}
else
{
	$Hunger::FoodCost = 10;
	$Hunger::TickTime = 30;
	$Hunger::FoodFill = 10;
	$Hunger::EatPeeps = 0;
	$Hunger::Event = 1;
	$hunger::FoodHorse = 5;
}
$Hunger::On = 1;
$Hunger::FoodFill = 10;

AddDamageType("Hunger",   '%1 has died of hunger.',    '%2 lol how can you kill someone else of hunger? %1',1,1);
AddDamageType("Eat",   '%1 ate of himeself.',    '%2 has eaten %1.',1,1);

RegisterSpecialVar(GameConnection,"hunger","%this.hunger");
RegisterSpecialVar(GameConnection,"food","$food[%this.bl_id]");
	
//Package for joining and leaving game
package Hunger
{
   	function GameConnection::autoAdminCheck(%client)
   	{   
   	Parent::autoAdminCheck(%client);
	%client.hunger = 100;
	//$decay[%client] = schedule($Hunger::TickTime,0,"hungerdecay",%client);
	if(!$food[%client.bl_id])
	{
		$food[%client.bl_id] = 2;
	}
	%client.canBuyFood = 0;
   	}
   	
   	function GameConnection::OnClientEnterGame(%client)
	{
		Parent::OnClientEnterGame(%client);
		%client.hasSpawned = 1;
		
		if(!$hungerTick && $Hunger::On == 1)
			hungerTick();
	}

	function player::activateStuff(%obj)
	{
		Parent::activateStuff(%obj);
		if($Hunger::On == 1 && $Hunger::EatPeeps == 1)
		{
			%client = %obj.client;
				%target = containerRayCast(%client.player.getEyePoint(), vectorAdd(vectorScale(vectorNormalize(%client.player.getEyeVector()), 8), %client.player.getEyePoint()),$typeMasks::playerObjectType).client;
				if(isObject(%target))
				{
					if(%client.hunger >= 100)
					{
						commandToClient(%client, 'CenterPrint', "\c6You're full!!", 2);
						return;
					}
					
					if(getRandom(0, 100) >= 85)
					{
						return;
					}
				
					commandToClient(%target, 'CenterPrint', %client.getPlayerName() @ " is eating you!", 1);
					%target.player.damage(%client.player, %target.player.getTransform, 3, $DamageType::Eat);
					
					%client.hunger = %client.hunger + 5;
					%client.player.addHealth(3);
					if(%client.hunger > 100)
					{
						%client.hunger = 100;
					}
					commandToClient(%client, 'CenterPrint', "\c6You ate a peice of \c3" @ %target.getPlayerName() @ "\c6.", 1);
					showhunger(%client, 1);
			}
		}
				
	}

	function brickFoodShopData::onPlant(%this,%brick)
	{
 				
		Parent::onPlant(%this,%brick);
 		schedule(100,0,"foodshop",%brick);

	}

	function brickFoodShopData::onRemove(%this,%brick)
	{
 		Parent::onRemove(%this,%brick);
 		if(isObject(%brick.trigger)){%brick.trigger.delete();}
	}	
	
	function HorseArmor::damage(%this, %obj, %sourceObject, %position, %damage, %damageType)
	{
		parent::damage(%this, %obj, %pos, %damage, %damageType);
		%obj.LastAttacker = %sourceObject.CLient;
		//echo(%obj.LastAttacker);
	}
	
	function HorseArmor::ondisabled(%this,%obj)
	{
		parent::ondisabled(%this,%obj);
		if($Hunger::On == 1 && $hunger::FoodHorse > 0)
		{
			%r = getRandom(-2, 2);
			%food = %r + $hunger::FoodHorse;
			if(%food < 1)
				%food = 1;
			
			$food[%obj.LastAttacker.bl_id] = $food[%obj.LastAttacker.bl_id] + %food;	
			messageClient(%obj.LastAttacker, '', "\c6You get \c3" @ %food @ "\c6 food from the horse. You now have\c3 " @ $food[%obj.LastAttacker.bl_id]  @ "\c6 food.");

		}
	}
};
activatePackage(Hunger);

function hungerTick()
{
	cancel($hungerTick);
	
	if($Hunger::On == 1)
	{
		for(%i=0;%i<ClientGroup.getCount();%i++)
		{
			%cl = ClientGroup.getObject(%i);
			hungerDecay(%cl);
		}	
			
		%time = $Hunger::TickTime * 1000;
		//echo(%time);
		if(isObject(ServerConnection) || $Server::Dedicated == 1)
			$hungerTick = schedule(%time,0,hungerTick);
	}
}


function serverCmdCheckHunger(%client)
{
	if($Hunger::On == 1)
	{
		showhunger(%client);
	}
	else
	{
		messageClient(%client, "", "\c6Hunger is currently disabled.");
	}
}

function serverCmdGiveFood(%client, %am)
{
	if(%am <= 0)
	{
		messageClient(%client, '', "\c6Invalid Amount");
		return;
	}
	
	if(%am > $food[%client.bl_id])
	{
		messageClient(%client, '', "\c6You don't have that much food.");
		return;
	}
	
	%target = containerRayCast(%client.player.getEyePoint(), vectorAdd(vectorScale(vectorNormalize(%client.player.getEyeVector()), 8), %client.player.getEyePoint()),$typeMasks::playerObjectType).client;
	if(isObject(%target))
	{
		$food[%client.bl_id] = $food[%client.bl_id] - %am;
		$food[%target.bl_id] = $food[%target.bl_id] + %am;
		messageClient(%client, '', "\c6You gave \c3" @ %am @ "\c6 food to\c3 " @ %target.getPlayerName() @ "\c6. You now have \c3" @ $food[%client.bl_id] @ "\c6 total food.");
		messageClient(%target, '', "\c3" @ %client.getPlayerName() @ "\c6 has given  you \c3" @ %am @ "\c6 food. You now have \c3" @ $food[%target.bl_id] @ "\c6 total food.");
	}
	else
	{
		messageClient(%client, '', "\c6You must be looking at someone to give them food.");
	}
}

function hungerDecay(%client)
{
	if($Hunger::On == 0 || %client.hasSpawned == 0)
	{
		return;
	}

	%hungerl = %client.hunger;
	%client.hunger = %hungerl - 10;
	if(%client.hunger <= 0)
	{
		//%client.Player.kill();
		//messageAll("", %client.getPlayerName() @ " has died of hunger.");
		if(isObject(%client.player)) 
		{
			%client.player.damage(%client.player, %client.player.getTransform, 100, $DamageType::Hunger);
		}
		%client.hunger = 70;
	}
	else 
	{
		showhunger(%client, 0);
	}
}

function showhunger(%client, %food)
{
	if(%food == 1)
	{
		%foodString = "now ";
	}
	else
	{
		%foodString = "";
	}
	
	if(%client.hunger >= 80)
	{
		messageclient(%client,"","\c6Your hunger level is " @ %foodString @ "\c2" @ %client.hunger @ "/100\c6.");
	}
	else if(%client.hunger >= 50 && %client.hunger < 80)
	{
		messageclient(%client,"","\c6Your hunger level is " @ %foodString @ "\c3" @ %client.hunger @ "/100\c6.");
	}
	else
	{
		messageclient(%client,"","\c6Your hunger level is " @ %foodString @ "\c0" @ %client.hunger @ "/100\c6.");
	}
}

//Shops

datablock TriggerData(Shop){
   tickPeriodMS = 100;
};

function shop::onEnterTrigger(%this, %trigger, %obj){
	if(!%obj.client.inshop){// if the enteree isnt already inside
	%obj.client.inshop = 1;
	if($Cash::CurrencyBefore)
	{
      	messageClient(%obj.client, "", "\c6Welcome to the food shop, type \c3/buyFood [amount]\c6 to buy food. The food price is \c3" @ $Cash::Currency @ $Hunger::FoodCost @ "\c6.");
	}
	else
	{
		messageClient(%obj.client, "", "\c6Welcome to the food shop, type \c3/buyFood [amount]\c6 to buy food. The food price is \c3" @ $Hunger::FoodCost @ $Cash::Currency @ "\c6.");
	}
}	
}

function shop::OnLeaveTrigger(%thid, %trigger, %obj){
	if(%obj.client.inshop){//make sure they're actually inside
	%obj.client.inshop = 0;//hes no longer inside
      messageClient(%obj.client, "", "\c6You have left the shop.");
  }
}

function serverCmdBuyFood(%client, %amount)
{
	if(!$Hunger::On)
	{
		messageClient(%client, "", "\c6Hunger is currently disabled.");
		return;
	}
	
	if(%amount < 0)
	{
		return;
	}
	
	if(!%amount)
	{
		%amount = 1;
	}
	
	%amount = mFloor(%amount);
	if(%client.inshop)
	{	
	%cost = $Hunger::FoodCost * %amount;
		if(%client.cashobj.cash >= %cost)
		{
			if(isObject(%client.cashobj))
			{
				%client.cashobj.mod("cash",0 - %cost);
			}
			$food[%client.bl_id] = $food[%client.bl_id] + %amount;
			messageClient(%client, "", "\c6You have bought \c3" @ %amount @ " \c6food. You now have \c3" @ $food[%client.bl_id] @ "\c6 total food.");
			messageClient(%client, "", "\c6Type \c3/eatFood [amount]\c6 to eat it.");
		}
		else
		{
			messageclient(%client,"","\c6You Do not have enough money to buy that much food!");
		}

	}
	else
	{
		messageClient(%client, "", "\c0You are not in a food shop.");
	}
}

function serverCmdEatFood(%client, %amount)
{
	if(!$Hunger::On)
	{
		messageClient(%client, "", "\c6Hunger is currently disabled.");
		return;
	}
		
	if(%amount < 0)
	{
		return;
	}
	
	if(!%amount)
	{
		%amount = 1;
	}
	
	if($food[%client.bl_id] < 1)
	{
		messageclient(%client,"","\c6You do not have any food to eat!");
		return;
	}

	if($food[%client.bl_id] < %amount)
	{
		%amount = $food[%client.bl_id];
	}
		
	%minfull = 100 - $Hunger::FoodFill * %amount;
	if(%client.hunger <= %minfull)
	{
		%client.hunger = %client.hunger + $Hunger::FoodFill * %amount;
		$food[%client.bl_id] = $food[%client.bl_id] - %amount;
		showhunger(%client, 1);
		commandToClient(%client, 'CenterPrint', "\c6You ate \c3" @ %amount @ "\c6 food. You have \c3" @ $food[%client.bl_id] @ "\c6 food remaining.", 4);
		%heal = %amount * 10;
		%client.player.addHealth(%heal);
	}
	else
	{
		messageclient(%client,"","\c6You are not hungery enough to eat that much food, please wait until your hunger level is \c3" @ %minfull @ " \c6or less");
	}	

}

function foodshop(%brick)
{
	if(%brick.getGroup().client.isSuperAdmin || %brick.getGroup().client.isAdmin){
	%posx = getWord(%brick.position,0);
	%posy = getWord(%brick.position,1);
	%posz = getWord(%brick.position,2);
	%posx = %posx - 0.5;
	%posy = %posy + 0.5;
	
	%temp = new trigger() {
	Datablock = "Shop";
	position = %posx SPC  %posy SPC %posz;
	scale = "1 1 1";
	rotation = "0 0 0 0";
	polyhedron = "0.0000000 0.0000000 0.0000000 1.0000000 0.0000000 0.0000000 0.0000000 -1.0000000 0.0000000 0.0000000 0.0000000 1.0000000";
	};
	%brick.trigger = %temp;
	MissionCleanup.add(%temp);
  	}
	else
	{
	messageClient(%brick.getGroup().client, "", "This brick is admin only!");
	%brick.killbrick();
	}

}

//Setting Commands

function serverCmdHungerHelp(%client)
{
	messageclient(%client,"","\c3/eatFood [Amount]\c6 - Eat [Amount] food.");
	messageclient(%client,"","\c3/giveFood [Amount]\c6 - Give food to who you're looking at.");
	messageclient(%client,"","\c3/checkHunger \c6 - See your hunger level.");
	messageclient(%client,"","\c3/hunger\c6 - Turns hunger on/off. \c3(Admin Only)");
//	messageclient(%client,"","\c3/eatPeople\c6 - Turns Cannibalism on/off. \c3(Admin Only)");
//	messageclient(%client,"","\c3/hungerTickTime [Seconds]\c6 - Sets the hunger tick time. \c3(Admin Only)");
//	messageclient(%client,"","\c3/hungerEvent\c6 - Turns the incHunger event on/off. \c3(Admin Only)");
//	messageclient(%client,"","\c3/foodCost [Price]\c6 - Sets the food cost. \c3(Admin Only)");
}

function serverCmdHunger(%client, %temp)
{
	if(%client.isSuperAdmin || %client.isAdmin)
	{
		if($Hunger::On == 1)
		{
			$Hunger::On = 0;
			messageall("","\c6Hunger has been turned \c3off\c6.");
			cancel($hungerTick);
		}
		else
		{
			$Hunger::On = 1;
			messageall("","\c6Hunger has been turned \c3on\c6.");
			hungerTick();
		}
	}		
}
//
//function serverCmdEatPeople(%client)
//{
//	if(%client.isSuperAdmin || %client.isAdmin)
//	{
//		if($Hunger::EatPeeps == 1)
//		{
//			$Hunger::EatPeeps = 0;
//			messageall("","\c6Cannibalism has been turned \c3off\c6.");
//		}
//		else
//		{
//			$Hunger::EatPeeps = 1;
//			messageall("","\c6Cannibalism has been turned \c3on\c6.");
//		}
//	}		
//}
//
//function serverCmdHungerTickTime(%client, %temp)
//{
//	if(%temp <= 0)
//	{
//		%temp = 1;
//	}
//	
//	if(%client.isSuperAdmin || %client.isAdmin)
//	{
//		$Hunger::TickTime = %temp;
//		messageAll("","\c6The hunger tick time is now \c3" @ %temp @ "\c6 seconds.");
//	}		
//}
//
//function serverCmdHungerEvent(%client)
//{
//	if(%client.isSuperAdmin || %client.isAdmin)
//	{
//		if($Hunger::Event == 1)
//		{
//			$Hunger::Event = 0;
//			messageall("","\c6The incHunger event has been disabled.");
//		}
//		else
//		{
//			$Hunger::Event = 1;
//			messageall("","\c6The incHunger event has been enabled.");
//		}
//	}		
//}
//
//function serverCmdFoodCost(%client, %temp)
//{
//	if(%client.isSuperAdmin || %client.isAdmin)
//	{
//		$Hunger::FoodCost = %temp;
//		messageAll("","\c6The food cost is now \c3" @ $Hunger::FoodCost @ "\c6.");
//	}		
//}


//Events
registerOutputEvent(GameConnection, "incHunger", "int -90 100 10", 0);
registerOutputEvent(GameConnection, "addFood", "int 0 100 1", 0);
registerOutputEvent(fxDTSBrick, "ifPlayerHunger", "list Equals 1 NotEquals 2 Greater 3 Less 4 GreaterEquals 5 LessEquals 6\tint 0 100 50", 1);

function GameConnection::incHunger(%client, %amount)
{
	if(!$Hunger::On)
	{
		messageClient(%client, "", "\c7incHunger: \c6Hunger is currently disabled.");
		return;
	}
	
	if($Hunger::Event == 1)
	{
		%client.hunger = %client.hunger + %amount;
		if(%client.hunger > 100)
			%client.hunger = 100;
		if(%client.hunger < 0)
			%client.hunger = 0;
			
		showhunger(%client, 0);
	}
	else
	{
		messageClient(%client,"","\c7incHunger: \c6This event is disabled.");
	}
}

function GameConnection::addFood(%client, %amount)
{
	if(!$Hunger::On)
	{
		messageClient(%client, "", "\c7addFood: \c6Hunger is currently disabled.");
		return;
	}
	
	if($Hunger::Event == 1)
	{
		$food[%client.bl_id] = $food[%client.bl_id] + %amount;
		messageClient(%client, "", "\c6You have \c3" @ $food[%client.bl_id] @ "\c6 food.");
	}
	else
	{
		messageClient(%client,"","\c7addFood: \c6This event is disabled.");
	}
}

//DATABLOCK

datablock fxDTSBrickData(brickFoodShopData : brick2x2fdata)
{
 uiName = "Food Shop Point";
 Category = "Special";
 subCategory = "Food Script";
};

//datablock fxDTSBrickData(brick3x3flatData)
//{
//	brickFile = "./3x3f.blb";
//	category = "Special";
//	subCategory = "Food Script";
//	uiName = "Corn Plant";
//	//iconName = "Add-Ons/Brick_Large_Cubes/4x Cube";
//};